/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package photostrip;

import java.net.URL;
import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

/**
 *
 * @author joshy
 */
public class Applet extends JApplet {

    private PhotoStrip strip;

    /**
     * Initialization method that will be called after the applet is loaded
     * into the browser.
     * 
     *  <param name="flickruser" value="31706743@N00"/>
        <param name="size" value="150"/>
        <param name="length" value="5"/>
     * 
     */
    @Override
    public void init() {
        System.out.println("init");
        
        String username = this.getParameter("flickruser");
        String size = this.getParameter("size");
        if(size == null) size = "150";
        String cols = this.getParameter("cols");
        if(cols == null) cols = "4";
        String rows = this.getParameter("rows");
        if(rows == null) rows = "1";
        
        String orientation = this.getParameter("orientation");
        if(orientation == null) orientation = "h";
        
        
        final String feedURL = "http://api.flickr.com/services/feeds/photos_public.gne?id="+username+"&lang=en-us&format=atom";
        final int colsi = Integer.parseInt(cols);
        final int rowsi = Integer.parseInt(rows);
        final int sizei = Integer.parseInt(size);
        
        // TODO start asynchronous download of heavy resources
        SwingUtilities.invokeLater(new Runnable() {

            public void run() {
                setContentPane(new JLabel("Loading Photo Strip"));
                if (strip == null) {
                    strip = new PhotoStrip(
                            feedURL,
                            colsi,
                            rowsi,
                            sizei,
                            new URLShower() {
                                public void showDocument(URL url) {
                                    getAppletContext().showDocument(url);
                                }
                            }
                            );
                    setContentPane(strip);
                }
            }
        });
    }

    // TODO overwrite start(), stop() and destroy() methods
}
